#include "stdafx.h"
/*
void GenerateFileTime(FILETIME *ftCMA, SYSTEMTIME *stDate, SYSTEMTIME *stTime) {
	TIME_ZONE_INFORMATION tzInfo;
	SYSTEMTIME SysTime, SysUTC;
   // Combine Date Control's Date and the Time Control's Time
  // into one Complete SYSTEMTIME Structure Date & Time TimeStamp.
  SysTime.wYear			= stDate->wYear;
  SysTime.wMonth		= stDate->wMonth;
  SysTime.wDayOfWeek	= stDate->wDayOfWeek;
  SysTime.wDay			= stDate->wDay;
  SysTime.wHour			= stTime->wHour;
  SysTime.wMinute		= stTime->wMinute;
  SysTime.wSecond		= stTime->wSecond;
  SysTime.wMilliseconds = stTime->wMilliseconds;

  GetTimeZoneInformation(&tzInfo);
  TzSpecificLocalTimeToSystemTime(&tzInfo, &SysTime, &SysUTC);
  SystemTimeToFileTime(&SysUTC, ftCMA);
}*/

  //===========================================
 //
//=============================================
void ChangeFiFoTimes(char *szPath, FILETIME ftCreated, FILETIME ftModified, FILETIME ftAccessed, 
						   BOOL bChangeAtt, BOOL bBypassAtt, BOOL bRead, BOOL bSyst, BOOL bHide) {
	DWORD dwAttrib;
	HANDLE hFile; 

    // IF We're Changing the File/Folder's Attributes, Do it Now! Or...
  if(bChangeAtt) SetFiFoAttributes(szPath, bRead, bSyst, bHide);

	// IF We're Only going to ByPass the File/Folder's Current Attributes...
  if(bBypassAtt) { // --- Remember "We" Have Stored the Current Attributes to ReApply Later.
     dwAttrib = GetFileAttributes(szPath); // Store the Current Attributes to ReApply Later.
	 SetFileAttributes(szPath, FILE_ATTRIBUTE_NORMAL); // ...Strip the Current Attributes...
  }

	// Try to Open the Target File.
  hFile = CreateFile(szPath, GENERIC_READ | GENERIC_WRITE,FILE_SHARE_READ |
	                 FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);

  	// Let User Know IF "We" Can't.
  if(hFile == INVALID_HANDLE_VALUE) {
	 MessageBox(0, "Open File Handle Failed!", "ERROR: Invalid File Handle", MB_OK|MB_ICONERROR);
	 return;
  }

	  // Update the File/Folder TimeStamps
  BOOL bSetTime = SetFileTime(hFile, &ftCreated, &ftAccessed, &ftModified);
	// Let User Know What (If AnyThing) Went Wrong
  if(!bSetTime) {
		char *szBuff = (char*)malloc(sizeof(char)*1024);
		int err = GetLastError();
		LPVOID lpMsgBuf;

	 FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM, NULL, 
				   err, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf, 0, NULL);

	 sprintf_s(szBuff, 1024, "Unable to Change TimeStamps on:\n  %s \n\nReason: %s \nError Code: %d", szPath, lpMsgBuf, err),

		MessageBox(0, szBuff, "GetLastError", MB_OK|MB_ICONERROR);
		LocalFree(lpMsgBuf);
  }
  CloseHandle(hFile); // Close the File/Folder Handle
  if(bBypassAtt) SetFileAttributes(szPath, dwAttrib); // ReApply Stored Attributes!
}



   //========================================================================
  // --------------- Read the Selected File or Folder's Created, Accessed,
 // ------------- and Modified Time Stamps and then Display Them to the User.
//===========================================================================
void ShowFiFoTimes(HWND hWnd, char *szPath) {
	FILETIME ftCreated, ftModified, ftAccessed;
    SYSTEMTIME sysDate, sysUTC;
	HANDLE hFile; BOOL bGotTime;

	// Try to Open the Target File.
  hFile = CreateFile(szPath, GENERIC_READ, FILE_SHARE_DELETE | FILE_SHARE_READ |
	                 FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);

	// Let User Know IF "We" Can't.
  if(hFile == INVALID_HANDLE_VALUE)
	 MessageBox(hWnd, "Open File Handle Failed!", "ERROR: Invalid File Handle", MB_OK|MB_ICONERROR);

	// Try to Read the File/Folder TimeStamps.
  bGotTime = GetFileTime(hFile, &ftCreated, &ftAccessed, &ftModified);

  if(!bGotTime)  //Let User Know IF "We" Can't Read the Time Stamps
	 MessageBox(hWnd, "Read File Times Failed!", "ERROR: Read Failure", MB_OK|MB_ICONERROR);

  CloseHandle(hFile); // Close the File Handle

	  // First Convert FileTime to System UTC/GMT/Zulu Time
  FileTimeToSystemTime(&ftCreated, &sysUTC);
    // Then Convert the System UTC/GMT/Zulu Time to the Locally Displayed Time Zone Time.
  SystemTimeToTzSpecificLocalTime(NULL, &sysUTC, &sysDate); 
  // UpDate FixWhen's Displayed TimeStamps to Reflect the Selected File/Folder's TimeStamps
  DateTime_SetSystemtime(GetDlgItem(hWnd, DATE_CREATED), GDT_VALID, (LPARAM)&sysDate);
  DateTime_SetSystemtime(GetDlgItem(hWnd, TIME_CREATED), GDT_VALID, (LPARAM)&sysDate);

	//Now Repeat for File/Folder Last Accessed & Modified Times.
  FileTimeToSystemTime(&ftAccessed, &sysUTC);
  SystemTimeToTzSpecificLocalTime(NULL, &sysUTC, &sysDate);
  DateTime_SetSystemtime(GetDlgItem(hWnd, DATE_ACCESSED), GDT_VALID, (LPARAM)&sysDate);
  DateTime_SetSystemtime(GetDlgItem(hWnd, TIME_ACCESSED), GDT_VALID, (LPARAM)&sysDate);

  FileTimeToSystemTime(&ftModified, &sysUTC);
  SystemTimeToTzSpecificLocalTime(NULL, &sysUTC, &sysDate);
  DateTime_SetSystemtime(GetDlgItem(hWnd, DATE_MODIFIED), GDT_VALID, (LPARAM)&sysDate);
  DateTime_SetSystemtime(GetDlgItem(hWnd, TIME_MODIFIED), GDT_VALID, (LPARAM)&sysDate);

  GetFiFoAttributes(hWnd, szPath);
}