// FixWhen.cpp : Defines the entry point for the application.
#include "stdafx.h"

// Main Program Message Loop
BOOL CALLBACK FixWhenProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM)
{	char *szPath;
switch(uMsg) {
  case WM_INITDIALOG:
	  InitCommonControls();
	break;

  case WM_COMMAND:
	  if(wParam == IDC_SAVE_BUTTON) {
		  char szTemp[MAX_PATH+2];
	     GetDlgItemText(hDlg, IDC_PATH, szTemp, MAX_PATH+2);
		 if(strlen(szTemp) > 0) ReadGUIOnce(hDlg, szTemp);
		 else MessageBox(hDlg, "No File or Folder has been Selected for this UpDate!", "ERROR: No Target Path", MB_OK|MB_ICONERROR);
	  }
	  if(wParam == IDC_CHANGE_ATTRIBS) {
	     BOOL isChk = IsDlgButtonChecked(hDlg, IDC_CHANGE_ATTRIBS);
		 for(int i = IDC_HIDDEN; i <= IDC_SYSTEM; i++)
			 EnableWindow(GetDlgItem(hDlg, i), isChk);
	  }
	  if(wParam == IDC_FOLDER_BUTTON) {
	     szPath = OpenFolderDlg(hDlg);
		 if(strlen(szPath) > 0) {
		    SetDlgItemText(hDlg, IDC_PATH, szPath);
		    ShowFiFoTimes(hDlg, szPath);
		 }
	  }
	  if(wParam == IDC_FILE_BUTTON) {
	     szPath = OpenFileDlg(hDlg);
		 if(strlen(szPath) > 0) {
		    SetDlgItemText(hDlg, IDC_PATH, szPath);
		    ShowFiFoTimes(hDlg, szPath);
		 }
	  }
	  if(wParam == IDC_REFRESH) {
		  char szTemp[MAX_PATH+2];
	     GetDlgItemText(hDlg, IDC_PATH, szTemp, MAX_PATH+2);
	     if(strlen(szTemp) > 0) ShowFiFoTimes(hDlg, szTemp);
		 else MessageBox(hDlg, "No File or Folder has been Selected.", "ERROR: No Target Path", MB_OK|MB_ICONERROR);
	  }
	  if(wParam == IDCANCEL)
	     EndDialog(hDlg, 0);
  }
return FALSE;
}
// WinMain ... Kinda Obvious Huh?
int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow) {
  DialogBoxParam (hInst, (LPCTSTR)MAKEINTRESOURCE(IDD_FIXWHEN), NULL, (DLGPROC)FixWhenProc, SW_SHOW);
 return TRUE;
}
  //=============================================================================*
 // Convert Local Time Zone GUI TimeStamps into UTC/GMT/Zulu FileTime TimeStamps.
//=============================================================================*
void GenerateFileTime(FILETIME *ftCMA, SYSTEMTIME *stDate, SYSTEMTIME *stTime) {
	TIME_ZONE_INFORMATION tzInfo;
	SYSTEMTIME SysTime, SysUTC;
   // Combine Date Control's Date and the Time Control's Time
  // into one Complete SYSTEMTIME Structure Date & Time TimeStamp.
  SysTime.wYear			= stDate->wYear;
  SysTime.wMonth		= stDate->wMonth;
  SysTime.wDayOfWeek	= stDate->wDayOfWeek;
  SysTime.wDay			= stDate->wDay;
  SysTime.wHour			= stTime->wHour;
  SysTime.wMinute		= stTime->wMinute;
  SysTime.wSecond		= stTime->wSecond;
  SysTime.wMilliseconds = stTime->wMilliseconds;

  GetTimeZoneInformation(&tzInfo);
  TzSpecificLocalTimeToSystemTime(&tzInfo, &SysTime, &SysUTC);
  SystemTimeToFileTime(&SysUTC, ftCMA);
}
   //============================================================================
  // -------------------- Read ALL User Specified Options from the GUI (Once!)...
 // ------------------- ...and Then Pass Them to the Various Functions As Needed.
//===============================================================================
void ReadGUIOnce(HWND hWnd, char *szPath) {
	FILETIME ftCreated, ftModified, ftAccessed;
	SYSTEMTIME sysDate, sysTime;

		// Find Out IF We're ByPassing Target Attributes.
  BOOL bBypassAtt = IsDlgButtonChecked(hWnd, IDC_BYPASS_ATTRIBS);
	  // Find Out IF We're Changing the Target's Attributes.
  BOOL bChangeAtt = IsDlgButtonChecked(hWnd, IDC_CHANGE_ATTRIBS);
	// Find Out Which Attributes We Want...Now.
  BOOL bRead = IsDlgButtonChecked(hWnd, IDC_READONLY);
  BOOL bSyst = IsDlgButtonChecked(hWnd, IDC_SYSTEM);
  BOOL bHide = IsDlgButtonChecked(hWnd, IDC_HIDDEN);

  	// Generate the File/Folder Created TimeStamp
  DateTime_GetSystemtime(GetDlgItem(hWnd,DATE_CREATED), (LPARAM)&sysDate);
  DateTime_GetSystemtime(GetDlgItem(hWnd,TIME_CREATED), (LPARAM)&sysTime);
  GenerateFileTime(&ftCreated, &sysDate, &sysTime);
	// Generate the File/Folder Last Modified TimeStamp
  DateTime_GetSystemtime(GetDlgItem(hWnd,DATE_MODIFIED), (LPARAM)&sysDate);
  DateTime_GetSystemtime(GetDlgItem(hWnd,TIME_MODIFIED), (LPARAM)&sysTime);
  GenerateFileTime(&ftModified, &sysDate, &sysTime);
	// Generate the File/Folder Last Accessed TimeStamp
  DateTime_GetSystemtime(GetDlgItem(hWnd,DATE_ACCESSED), (LPARAM)&sysDate);
  DateTime_GetSystemtime(GetDlgItem(hWnd,TIME_ACCESSED), (LPARAM)&sysTime);
  GenerateFileTime(&ftAccessed, &sysDate, &sysTime);

  BOOL bAllFiles = IsDlgButtonChecked(hWnd, IDC_APPLY_ALL);
  if(bAllFiles) {
     ChangeFiFoTimes(szPath, ftCreated, ftModified, ftAccessed, bChangeAtt, bBypassAtt, bRead, bSyst, bHide);
     FindAllContents(0, szPath, ftCreated, ftModified, ftAccessed, bChangeAtt, bBypassAtt, bRead, bSyst, bHide);
  }
  else ChangeFiFoTimes(szPath, ftCreated, ftModified, ftAccessed, bChangeAtt, bBypassAtt, bRead, bSyst, bHide);
}